<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
// import Joomla controlleradmin library
jimport('joomla.application.component.controller');

class osmaControllerChiamate extends JControllerLegacy
{

    public static function response($response)
    {
        $document = &JFactory::getDocument();
        $document->setMimeEncoding('application/json');

        echo json_encode($response);
        exit;
    }

    public function stampa()
    {
        $model = $this->getModel('chiamate');
        $model->stampa();
    }

    public function inviaComunicazione()
    {

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $post = JRequest::get('post');

        $query->select("c.*, g.*")->from("#__osma_chiamate c")
            ->innerJoin("#__osma_anagrafica_gestori g ON g.idGestore = c.idGestore")
            ->where("idChiamata = {$post['idChiamata']}");
        $db->setQuery($query);

        $data = $db->loadObject();
        $query->clear();
        $oggettoMail = "Comunicazione relativa alla chiamata #{$data->nrChiamata} - {$data->ragioneSociale}, {$data->indirizzo}, {$data->comune} ({$data->provincia})";

        $mailer = JFactory::getMailer();
        $mailer->setSender(array(JFactory::getUser()->get('email'), JFactory::getUser()->get('name')));

        $to = array();

        if ($post['fromAdmin']) {
            if ($post['inviaA'] && $post['inviaA'] != "") {
                $to=array($post['inviaA']);
            } else {
                if (is_numeric($post['to'])) {
                    $query->select("email")->from("#__users")->where("id = {$post['to']}");
                    $db->setQuery($query);
                    $to[] = $db->loadResult();
                    $query->clear();
                } elseif ($post['to'] == 'cliente') {
                    $query->select("*")->from("#__osma_clienti_contatti")->where("idCliente = {$data->idCliente} AND email IS NOT NULL")->order("email");
                    $db->setQuery($query);

                    foreach ($db->loadObjectList() as $mail) {
                        $to[] = $mail->email;
                    }
                    $query->clear();
                    $to = array_unique($to);
                } elseif ($post['to'] == 'punto-vendita') {
                    $query->select("*")->from("#__osma_gestori_contatti")->where("idGestore = {$data->idGestore} AND email IS NOT NULL")->order("email");
                    $db->setQuery($query);

                    foreach ($db->loadObjectList() as $mail) {
                        $to[] = $mail->email;
                    }
                    $query->clear();
                    $to = array_unique($to);
                } elseif ($post['to'] == 'ufficio') {
                    $to[] = COM_OSMA_MAIL_CHIUSURE;
                }
            }
        } else {
            $to[] = COM_OSMA_MAIL_TO;
        }

        if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
            $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
        }

        if ($post['attachment']) {
            foreach ($post['attachment'] as $uid => $file) {
                $mailer->addAttachment($file);
            }
        }

        if (empty($to)) {
            self::response(array(
                'status' => false,
                'message' => 'Nessun destinatario del messaggio impostato'
            ));
        }

        $body = "<p>" . JRequest::getVar('comunicazione') . "</p>";

        $mailer->addRecipient($to);
        $mailer->setSubject($oggettoMail);
        $mailer->isHTML(true);
        $mailer->Encoding = 'base64';
        $mailer->setBody($body);

        if ($mailer->Send() === true) {
            mailerHelper::logMail($mailer, 2, true, $post['idChiamata']);

            $data = new stdClass();
            $data->idChiamata = $post['idChiamata'];
            $data->idUtente = JFactory::getUser()->get('id');
            $data->comunicazione = JRequest::getVar('comunicazione');
            $data->allegati = serialize($post['attachment']);
            $data->destinatario = $to;

            $db->insertObject('#__osma_chiamate_comunicazioni', $data, 'idChiamata');

            self::response(array(
                'status' => true
            ));
        }
        mailerHelper::logMail($mailer, 2, false, $post['idChiamata']);
    }

    public function inviaNuovaComunicazione()
    {

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $post = JRequest::get('post');

        $oggettoMail = "Comunicazione da FuelManagment.it";

        $mailer = JFactory::getMailer();
        $mailer->setSender(array(JFactory::getUser()->get('email'), JFactory::getUser()->get('name')));

        $to = array();
        $to[] = COM_OSMA_MAIL_TO;

        if (JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug") && JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address")) {
            $mailer->addCC(JFactory::getApplication('site')->getParams("com_osma")->get("config_mail_debug_address"));
        }

        $body = "<p>" . JRequest::getVar('comunicazione') . "</p>";

        $mailer->addRecipient($to);
        $mailer->setSubject($oggettoMail);
        $mailer->isHTML(true);
        $mailer->Encoding = 'base64';
        $mailer->setBody($body);

        if ($mailer->Send()) {
            mailerHelper::logMail($mailer, 3, true);
            self::response(array(
                'status' => true
            ));
        }
        mailerHelper::logMail($mailer, 3, false);
    }

    public function addAttachments()
    {
        if ($_FILES['file'] && !$_FILES['file']['error']) {
            if (!is_dir(JPATH_COMPONENT . "/files/attachment")) {
                mkdir(JPATH_COMPONENT . "/files/attachment");
            }
            if (move_uploaded_file($_FILES['file']['tmp_name'], JPATH_COMPONENT . "/files/attachment/{$_FILES['file']['name']}")) {

                self::response(array(
                    'status' => true,
                    'id' => uniqid(),
                    'filename' => JPATH_COMPONENT . "/files/attachment/{$_FILES['file']['name']}"
                ));
            }
        }
        self::response(array(
            'status' => false
        ));
    }

    public function deletePreventivo(){
        $model = $this->getModel('chiamate');
        $model->deletePreventivo();
    }

}
