<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class OsmaModelPreventivatore extends JModelList {

    public function getTotal() {
        return count($this->getItems());
    }

    public function getCapitolato() {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("livello = 0")->order("prezziario ASC, codiceCapitolo ASC");

        $dbo->setQuery($query);
        $capitolato = $dbo->loadObjectList();
        $this->componi_albero($capitolato);

        return $capitolato;
    }

    private function componi_albero(&$capitolato,$level=0) {
        $dbo = JFactory::getDbo();
        $level=$level+1;
        $query = $dbo->getQuery(true);
        foreach ($capitolato as $k => $capitolo) {
            $query->clear();
            $query->select("*")->from("#__osma_preventivatore_capitolato")->where("idCapitoloGenitore = {$capitolo->idCapitolo}")->order("prezziario ASC, codiceCapitolo ASC");
            $dbo->setQuery($query);
            $sottocapitoli = $dbo->loadObjectList();
           /* if($level==3 ){
            	var_dump($sottocapitoli);
            	die();
            }*/
	        if (count($sottocapitoli)>0) {
                $capitolato[$k]->sottocapitoli = $sottocapitoli;

                $this->componi_albero($capitolato[$k]->sottocapitoli,$level);

            }
        }




    }

    public function getChiamata($idChiamata) {
        if (!$idChiamata) {
            return null;
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("c.*, cli.ragioneSociale as cRagioneSociale, ge.ragioneSociale as gRagioneSociale, ge.indirizzo as gIndirizzo, ge.comune as gComune, ge.provincia as gProvincia, ge.nrPuntoVendita as gNrPuntoVendita")
                ->from("#__osma_chiamate as c")
                ->innerJoin("#__osma_anagrafica_clienti as cli ON cli.idCliente = c.idCliente")
                ->innerJoin("#__osma_anagrafica_gestori as ge ON ge.idGestore = c.idGestore")
                ->where("c.idChiamata = {$idChiamata}");

        $chiamata = $dbo->setQuery($query)->loadObject();
		if($chiamata->idGestore) {
			$chiamata->emailGestore = $dbo->setQuery("SELECT email FROM #__osma_gestori_contatti WHERE email IS NOT NULL AND email != '' AND idGestore = " . $chiamata->idGestore . " LIMIT 0,1")->loadResult();
		}
	    if($chiamata->idCliente) {
		    $chiamata->emailCliente = $dbo->setQuery("SELECT email FROM #__osma_clienti_contatti WHERE email IS NOT NULL AND email != '' AND idCliente = " . $chiamata->idCliente . " LIMIT 0,1")->loadResult();
	    }

        return $chiamata;
    }

    public function getPreventivo() {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        if (JRequest::getVar("idPreventivo")) {
            $query->select("*")->from("#__osma_preventivatore_preventivi")->where("idPreventivo = " . JRequest::getVar("idPreventivo"));
            $dbo->setQuery($query);
            $preventivo = $dbo->loadObject();
        } elseif (JRequest::getVar("idChiamata")) {
            $query->select("*")->from("#__osma_preventivatore_preventivi")->where("idChiamata = " . JRequest::getVar("idChiamata"));
            $dbo->setQuery($query);

            $preventivo = $dbo->loadObject();

        }

        if ($preventivo) {

            $query->clear()->select("v.*, c.idCapitolo, c.codiceCapitolo, c.idCapitoloGenitore")->from("#__osma_preventivatore_preventivi_voci as v")->leftJoin("#__osma_preventivatore_capitolato as c ON c.idCapitolo = v.idCapitolo")->where("idPreventivo = " . $preventivo->idPreventivo)->order('v.orderId ASC');
            $preventivo->voci = $dbo->loadObjectList();
            foreach ($preventivo->voci as $voce) {
                if ($voce->idCapitolo) {
                    $voce->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($voce);
                }
            }

        }

        return $preventivo;
    }

    public function getPreventivi() {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select("p.*, c.*, cli.ragioneSociale, cli.comune")
                ->from("#__osma_preventivatore_preventivi as p")
                ->innerJoin("#__osma_chiamate c ON c.idChiamata = p.idChiamata")
                ->innerJoin("#__osma_anagrafica_clienti cli ON c.idCliente =cli.idCliente");

        return $dbo->setQuery($query)->loadObjectList();
    }

    public function getNextIdPreventivo() {

        return JFactory::getDbo()->setQuery("SELECT MAX(idPreventivo) + 1 FROM #__osma_preventivatore_preventivi")->loadResult();
    }

    public function getItems() {

        switch (JRequest::getVar("layout") ? JRequest::getVar("layout") : "default") {
            case 'default':
                return $this->getCapitolato();
            case 'preventivo':
                return $this->getPreventivo();
        }
    }

    public function getListini(){
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select('idCapitolo,nome')->from('#__osma_preventivatore_capitolato')->where('livello=0')->order('nome ASC');
        return $dbo->setQuery($query)->loadObjectList();
    }

    public function getCapitoli(){
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select('idCapitolo,codiceCapitolo,nome')->from('#__osma_preventivatore_capitolato')->where('livello=1')->order('codiceCapitolo ASC');
        return $dbo->setQuery($query)->loadObjectList();
    }

    public function getFamiglie(){
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select('idCapitolo,codiceCapitolo,nome')->from('#__osma_preventivatore_capitolato')->where('livello=2')->order('codiceCapitolo ASC');
        return $dbo->setQuery($query)->loadObjectList();
    }

    public function getVoci(){
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select('idCapitolo,codiceCapitolo,nome,prezzoUnitario,um')->from('#__osma_preventivatore_capitolato')->where('livello=3')->order('codiceCapitolo ASC');
        return $dbo->setQuery($query)->loadObjectList();
    }

    public function getSottoVoci(){
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select('idCapitolo,codiceCapitolo,nome,prezzoUnitario,um')->from('#__osma_preventivatore_capitolato')->where('livello=4')->order('codiceCapitolo ASC');
        return $dbo->setQuery($query)->loadObjectList();
    }

    public function ordinaVociPreventivo(){
        $dbo = JFactory::getDbo();

        $dataOrder = JRequest::getVar("orderIds");
        $dataVoci = JRequest::getVar("vociIds");

        foreach($dataOrder as $k=>$order) {
            $object = new stdClass();
            $object->idVoce=$dataVoci[$k]['value'];
            $object->orderId=$k;
            $result = $dbo->updateObject('#__osma_preventivatore_preventivi_voci', $object, 'idVoce');
        }
        return $result;
    }

    public function salvaVoce(){
        $dbo = JFactory::getDbo();

        $datiVoce= JRequest::getVar('dati');

        $voce = new stdClass();
        $voce->idPreventivo =$datiVoce['idPreventivo'];
        $voce->idCapitolo =$datiVoce['idCapitolo'];
        $voce->nome =$datiVoce['nome'];
        if(!$datiVoce['prezzoUnitario'] || $datiVoce['prezzoUnitario']==""){
            $voce->prezzoUnitario=0;
        }else{
            $voce->prezzoUnitario=$datiVoce['prezzoUnitario'];
        }
        if(!$datiVoce['quantita'] || $datiVoce['quantita']==""){
            $voce->quantita =0;
        }else{
            $voce->quantita =(int)$datiVoce['quantita'];
        }
        $voce->um =$datiVoce['um'];
        if(!$datiVoce['sconto'] || $datiVoce['sconto']==""){
            $voce->sconto =0;
        }else{
            $voce->sconto =$datiVoce['sconto'];
        }
        $voce->note =$datiVoce['note'];
        $voce->orderId=$datiVoce['orderId'];

        $result = $dbo->insertObject('#__osma_preventivatore_preventivi_voci', $voce);

        return $dbo->insertid();

    }

    public function eliminaVocePreventivo(){
        $dbo = JFactory::getDbo();

        $idVoce= JRequest::getVar('idVoce');

        $query = $dbo->getQuery(true);
        $query->delete($dbo->quoteName('#__osma_preventivatore_preventivi_voci'));
        $query->where('idVoce='.$idVoce);
        $dbo->setQuery($query);

        $result = $dbo->execute();

        return $result;

    }

    public function modificaVocePreventivo()
    {
        $dbo = JFactory::getDbo();
        $idVoce=JRequest::getVar('idVoce');
        $query = $dbo->getQuery(true);
        $query->select('a.*,b.livello')
            ->from('#__osma_preventivatore_preventivi_voci as a')
            ->join('left','#__osma_preventivatore_capitolato as b ON a.idCapitolo=b.idCapitolo')
            ->where('idVoce='.$idVoce);
        echo json_encode($dbo->setQuery($query)->loadObject());
    }



}
