<?php defined('_JEXEC') or die('Restricted access'); ?>

<div class="t3a-toolbar row">
    <div class="clearfix hidden-xs flex" style="align-items: center;">
        <?php echo $this->loadTemplate('form'); ?>
    </div>
    <div class="visible-xs col-xs-12 text-center"style="padding-top: 15px; padding-bottom: 15px">
        <a href="#filter-collapse" data-toggle="collapse" role="button" aria-expanded="false" aria-controls="filter-collapse"><i class="glyphicon glyphicon-filter"></i> Azioni e filtri</a>        
    </div>
    <div class="col-xs-12 collapse" id="filter-collapse">
        <?php echo $this->loadTemplate('form'); ?>
    </div>
</div>

<div class="panel panel-default main-panel ">
    <div class="panel-heading">
        <h2>Elenco scadenze</h2>
    </div>
    <div class="panel-body">
        <table class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th class="center" width="5%">ID</th>
                    <th width="20%">Gestore</th>
                    <th class="center" width="12%">Prossima scadenza</th>
                    <th class="left" width="12%">Scadenza</th>
                    <th></th>
                    <th class="center" width="5%"></th>
                    <th class="center" width="5%"></th>
                    <th class="center" width="5%"></th>
                    <th class="center" width="5%"></th>
                </tr>
            </thead>
            <tfoot>
                <tr>
                    <td colspan="9" class="t3a-pagination">
                        <form name='scadenziario' action='<?php echo osmaHelper::router("index.php?option=com_osma&view=amministrazione&layout=scadenziario") ?>' method="POST" >
                            <div class="col-md-6 text-left"><?php echo $this->pagination->getListFooter(); ?></div>
                            <div class="col-md-6 text-right">Nr. Risultati: <?php echo $this->pagination->getLimitBox(); ?></div>
                        </form>
                    </td>
                </tr>
            </tfoot>
            <tbody>
                <?php if ($this->items) { ?>
                    <?php foreach ($this->items as $item) { ?>
                        <tr>
                            <td class='center'><?php echo $item->idScadenza ?></td>
                            <td><?php echo $item->ragioneSociale ?></td>
                            <td class='center next-scadenza'><?php echo date("d/m/Y", strtotime($item->data)); ?></td>
                            <td class='left'>
                                <?php
                                switch ($item->scadenza) {
                                    case '1-week': echo 'Settimanale';
                                        break;
                                    case '1-month': echo 'Mensile';
                                        break;
                                    case '2-months': echo 'Bimestrale';
                                        break;
                                    case '6-months': echo 'Semestrale';
                                        break;
                                    case '1-year': echo 'Annuale';
                                        break;
                                }
                                ?>
                            </td>
                            <td></td>
                            <td class='center'>
                                <a href="<?php echo osmaHelper::router("index.php?option=com_osma&view=chiamata&idScadenza=" . $item->idScadenza . "&programmata=1&idGestore=" . $item->idGestore) ?>" class="btn btn-sm btn-info edit-scadenza" ><i class="fa fa-plus-circle"></i> Genera chiamata</a>
                            </td>
                            <td class='center'>
                                <a href="javascript:void(0);" class="btn btn-sm refresh-scadenza" data-id="<?php echo $item->idScadenza ?>" ><i class="fa fa-refresh"></i> Aggiorna scadenza</a>
                            </td>
                            <td class='center'>
                                <a href="javascript:void(0);" class="btn btn-sm edit-scadenza" data-id="<?php echo $item->idScadenza ?>" data-idgestore="<?php echo $item->idGestore ?>" data-scadenza="<?php echo $item->scadenza ?>" data-data="<?php echo date("d/m/Y", strtotime($item->data)) ?>" data-toggle='modal' data-target='#nuovaScadenza'><i class="fa fa-edit"></i> Modifica</a>
                            </td>
                            <td class='center'>
                                <a href="javascript:void(0);" class="btn btn-sm remove-scadenza" data-id="<?php echo $item->idScadenza ?>"><i class="fa fa-times-circle"></i> Elimina</a>
                            </td>
                        </tr>
                    <?php } ?>
                <?php } else { ?>
                    <tr>
                        <td colspan="9">Nessuna scadenza.</td>
                    </tr>
                <?php } ?>
            </tbody>
        </table>
    </div>
</div>

<div class="modal fade" id="nuovaScadenza" tabindex="-1" role="dialog" aria-labelledby="nuovaScadenza">
    <div class="modal-dialog" role="document">
        <form name="nuovaScadenza" action="index.php" method="POST">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Chiudi"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title">Scadenza</h4>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <div class="col-sm-12" style="margin-bottom: 15px;">
                            <select name="idGestore" class="chosen" data-placeholder="Seleziona il gestore">
                                <option value selected disabled></option>
                                <?php foreach ($this->gestori as $gestore) { ?>
                                    <option value='<?php echo $gestore->idGestore ?>'><?php echo $gestore->ragioneSociale ?> | <?php echo $gestore->ragioneSocialeCliente ?> | <?php echo $gestore->nrRea ?> | <?php echo $gestore->comune ?></option>
                                <?php } ?>
                            </select>
                        </div>
                        <div class="col-sm-6">
                            <input type="text" class="datetimepicker" name='data' placeholder="Data di riferimento" style='width: 100%;'/>
                        </div>
                        <div class="col-sm-6">
                            <select name="scadenza" class="chosen" data-placeholder="Seleziona la tipologia di scadenza">
                                <option value selected disabled></option>
                                <option value="1-week">Settimanale</option>
                                <option value="1-month">Mensile</option>
                                <option value="2-months">Bimestrale</option>
                                <option value="6-months">Semestrale</option>
                                <option value="1-year">Annuale</option>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <input type='hidden' name='idScadenza' value="" />
                    <button type="button" class="btn btn-default" data-dismiss="modal">Chiudi</button>
                    <button type="button" class="btn btn-primary">Salva</button>
                </div>
            </div>
        </form>
    </div>
</div>
<script>
    jQuery(function ($) {

        $(document).on("click", ".reset-form", function (e) {
            e.stopPropagation();
            e.stopImmediatePropagation();

            $(this).parents("form").find("input, select").val("");
        });
        $(document).on("click", ".edit-scadenza", function () {
            $("form[name='nuovaScadenza'] [name='idScadenza']").val($(this).data("id"));
            $("form[name='nuovaScadenza'] [name='scadenza'] option:selected").removeAttr("selected");
            $("form[name='nuovaScadenza'] [name='idGestore'] option:selected").removeAttr("selected");
            $("form[name='nuovaScadenza'] [name='scadenza'] option[value='" + $(this).data("scadenza") + "']").attr("selected", "selected");
            $("form[name='nuovaScadenza'] [name='idGestore'] option[value='" + $(this).data("idgestore") + "']").attr("selected", "selected");
            $("form[name='nuovaScadenza'] [name='data']").val($(this).data("data"));

            $("[name='scadenza']").trigger('chosen:updated');
            $("[name='idGestore']").trigger('chosen:updated');
        });
        $(document).on("click", ".refresh-scadenza", function () {
            $this = $(this);
            $this.find(".fa").addClass(".fa-spin");
            $.ajax({
                url: "index.php?option=com_osma&task=amministrazione.aggiornaScadenza&format=raw",
                data: {
                    idScadenza: $this.data("id")
                },
                method: 'POST'
            }).done(function (data) {
                data = JSON.parse(data);
                if (data.success) {
                    $this.parents("tr").find(".next-scadenza").html(data.data.data);
                    $this.parents("tr").find(".edit-scadenza").data("data", data.data.data);
                }
                $this.find(".fa").removeClass(".fa-spin");
            });
        });
        $(document).on("click", ".add-scadenza", function () {
            $("form[name='nuovaScadenza'] [name='idScadenza']").val("");
            $("form[name='nuovaScadenza'] [name='scadenza']").val("");
            $("form[name='nuovaScadenza'] [name='idGestore']").val("");
            $("form[name='nuovaScadenza'] [name='data']").val("");

            $("[name='scadenza']").trigger('chosen:updated');
            $("[name='idGestore']").trigger('chosen:updated');
        });
        $(".datetimepicker").datetimepicker({
            format: 'DD/MM/YYYY'
        });
        $(document).on("click", "form[name='nuovaScadenza'] .btn-primary", function () {
            $.ajax({
                url: "index.php?option=com_osma&task=amministrazione.salvaScadenza&format=raw",
                data: $("form[name='nuovaScadenza']").serialize(),
                method: 'POST'
            }).done(function (data) {
                data = JSON.parse(data);
                if (data.success) {
                    window.location.reload();
                }
            });
        });
    });
</script>